import javax.microedition.lcdui.*;

class MyCanvas extends Canvas implements Runnable {
	public static final int BALL_SIZE = 20;
	private int ball_x;
	private int ball_y;
	private int move_x;
	private int move_y;
	private boolean running;
	
	public MyCanvas(){
		ball_x = getWidth()/2;
		ball_y = getHeight()/2;
		move_x = 0;
		move_y = 0;
		running = true;
		Thread t = new Thread(this);
		t.start();
	}
	public void run(){
		while(running) {
			bound_check();
			repaint();
			try {
				Thread.sleep(200);
			}catch(InterruptedException e) {
				stop();
			}		
		}
	}
	public void paint(Graphics g) {		
		g.setColor(255,255,255);
		g.drawRect(0, 0, getWidth(), getHeight());
		g.setColor(0, 255, 0);
		ball_x += move_x;
		ball_y += move_y;
		g.fillArc(ball_x, ball_y, BALL_SIZE, BALL_SIZE, 0, 360);
	}
	public void keyPressed(int keycode) {
		switch(getGameAction(keycode)){
			case LEFT: 
				move_x = -10;
				move_y = 0;
				break;
			case RIGHT:
				move_x = 10;
				move_y = 0;
				break;
			case UP:
				move_x = 0;
				move_y = -10;
				break;
			case DOWN:
				move_x = 0;
				move_y = 10;
				break;
			default:
		}
	}
	private void bound_check() {
		if(ball_x > getWidth()){
			ball_x = getWidth();			
		} else if (ball_x < 0){
			ball_x = 0;
		}
		if(ball_y > getHeight()){
			ball_y = getHeight();			
		} else if (ball_y < 0){
			ball_y = 0;
		}
	}
	public void stop(){
		running = false;
	}
}