import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;

class MyGameCanvas extends GameCanvas implements Runnable {
	public  static final int BALL_SIZE = 20;
	private int ball_x;
	private int ball_y;
	private int move_x;
	private int move_y;
	private boolean running;
	public MyGameCanvas() {
		super(true);
		ball_x = getWidth()/2;
		ball_y = getHeight()/2;
		move_x = 0;
		move_y = 0;
		running = true;
		Thread t = new Thread(this);
		t.start();
	}		
	public void run(){
		Graphics g = getGraphics();
		while(running) {
			bound_check();
			g.setColor(255, 255, 255);
			g.drawRect(0, 0, getWidth(), getHeight());
			g.setColor(0, 255, 0);
			ball_x += move_x;
			ball_y += move_y;
			g.fillArc(ball_x, ball_y, BALL_SIZE, BALL_SIZE, 0, 360);
			flushGraphics();	
			int keyStates = getKeyStates();
			if((keyStates & LEFT_PRESSED)!= 0) {
				move_x = -10;
				move_y = 0;
			} else if((keyStates & RIGHT_PRESSED) != 0) {
				move_x = 10;
				move_y = 0;
			} else if((keyStates & UP_PRESSED) != 0) {
				move_x = 0;
				move_y = -10;
			}else if((keyStates & DOWN_PRESSED) != 0) {
				move_x = 0;
				move_y = 10;
			}		
			try {
				Thread.sleep(200);
			} catch(InterruptedException e) {
				stop();
			}
		}
	}
	private void bound_check() {
		if(ball_x > getWidth()) {
			ball_x = 0;			
		} else if (ball_x < 0) {
			ball_x = getWidth();
		}
		if(ball_y > getHeight()) {
			ball_y = 0;			
		} else if(ball_y < 0){
			ball_y = getHeight();
		}
	}
	public void stop() {
		running = false;
	}
}