import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;


public class MySprite extends Sprite {
	private int move_x;
	private int move_y;
	private int screenWidth;
	private int screenHeight;
	public int transformIndex;
	
	private static final int [] transformArray = {
		Sprite.TRANS_NONE,
		Sprite.TRANS_ROT90,
		Sprite.TRANS_ROT180,
		Sprite.TRANS_ROT270
	};
	
	public MySprite(Image img, int width, int height, 
			int screenWidth, int screenHeight){
		super(img, width, height);
		defineReferencePixel(width/2, height/2);
		move_x = 0;
		move_y = 0;
		transformIndex = 0;
		this.screenWidth = screenWidth;
		this.screenHeight = screenHeight;
	}
	public void setDirection(int move_x, int move_y){
		this.move_x = move_x;
		this.move_y = move_y;
	}
	public void move() {
		int x = (getRefPixelX() + move_x + screenWidth) % screenWidth;
		int y = (getRefPixelY() + move_y + screenHeight) % screenHeight;
		setRefPixelPosition(x, y);		
	}
	public void rotate() {
		transformIndex = (transformIndex + 1) % 4;
		setTransform(transformArray[transformIndex]);
	}
}
