import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.IOException;

class SpriteTransCanvas extends GameCanvas implements Runnable {
	private Sprite hany;
	String trans_info = "";
	private Image hany_img;
	private boolean running;
	int array_idx =0;
	int mirror_idx =0;
	private static final int [] transformArray = {
		Sprite.TRANS_NONE,
		Sprite.TRANS_ROT90,
		Sprite.TRANS_ROT180,
		Sprite.TRANS_ROT270
	};
	private static final int [] transMirrorArray = {
		Sprite.TRANS_MIRROR,
		Sprite.TRANS_MIRROR_ROT90,
		Sprite.TRANS_MIRROR_ROT180,
		Sprite.TRANS_MIRROR_ROT270
	};
	String transForm[] = new String[]{"Sprite.TRANS_NONE",
									  "Sprite.TRANS_ROT90",
									  "Sprite.TRANS_ROT180",
									  "Sprite.TRANS_ROT270"};
	String transMirror[] = new String[]{"Sprite.TRANS_MIRROR",
			                            "Sprite.TRANS_MIRROR_ROT90",
			                            "Sprite.TRANS_MIRROR_ROT180",
			                            "Sprite.TRANS_MIRROR_ROT270"};
	public SpriteTransCanvas() {
		super(true);
		try {
			hany_img = Image.createImage("/hany.png");
		}catch (IOException e){
			System.out.println("We can't read Image file");
		}
		hany = new Sprite(hany_img, 33, 40);
		running = true;
		play_hany();
		Thread t = new Thread(this);
		t.start();
	}
	public void run() {
		Graphics g = getGraphics();
		while(running) {
			int keyStates = getKeyStates();
			if((keyStates & LEFT_PRESSED)!= 0) {
				array_idx++;
				array_idx = array_idx%4;
				hany.setTransform(transformArray[array_idx]);
				trans_info = transForm[array_idx];
			} else if((keyStates & RIGHT_PRESSED) != 0) {
				if(array_idx == 0 ) array_idx = 3;
				else array_idx--;
				array_idx = array_idx %4;
				hany.setTransform(transformArray[array_idx]);
				trans_info = transForm[array_idx];
			} else if((keyStates & UP_PRESSED) != 0) {
				mirror_idx++;
				mirror_idx = mirror_idx%4;
				hany.setTransform(transMirrorArray[mirror_idx]);
				trans_info = transMirror[mirror_idx];
			} else if((keyStates & DOWN_PRESSED) != 0) {
				if(mirror_idx == 0) mirror_idx = 3;
				else mirror_idx--;
				mirror_idx = mirror_idx%4;
				hany.setTransform(transMirrorArray[mirror_idx]);
				trans_info = transMirror[mirror_idx];
			}
			draw_hany(g);
			try {
				Thread.sleep(200);
			} catch(InterruptedException e) {
				stop();
			}		
		}
	}
	private void play_hany() {
		hany.setTransform(Sprite.TRANS_NONE);
		hany.setPosition(getWidth()/2, getHeight()/2);
	}
	private void draw_hany(Graphics g) {
		g.setColor(255, 255, 255);
		g.fillRect(0, 0, getWidth(), getHeight());
		g.setColor(0, 0, 0);
		g.drawString(trans_info, 70, 200, Graphics.TOP | Graphics.LEFT);
		hany.paint(g);
		flushGraphics();
	}
	public void stop(){
		running = false;
	}
}