import javax.microedition.lcdui.*;
import javax.microedition.media.*;

import java.io.*;

public class LoadingCanvas extends Canvas implements Runnable{
	/* ΰ */
	private int logoCount;
	private byte gameState;
	private Thread thread;	
	private Image logo_img;	
	static final byte g_LOGO = 1;
	/**/
	private Image bg_img;
	static final byte g_NOTICE = 2;
	static final byte g_TITLE = 3;
	private Font largeFont;
	private Font italicFont;
	String explainText[] = {"< ̿ȳ >", "  ̿", " ", "߻ ʴ ܵ", 
			                 "Դϴ.", "Ƚϰ ̿ϼ.", "ƹŰ "};
	/* ̺Ʈ ó */
	private boolean isKeyPressed = false;
	private int keyCode;
	/* ŸƲ ̹ */
	private Image title1, title2, title3;
	/*  ó */
	private Player mPlayer;
	private boolean sound;
	/* ޴ ó */
	static final byte g_MENU = 4;
	static final byte g_LOADING = 5;
	private Image menu_img1, menu_img2, cursor;
	private byte menuSelect;
	private int width, height;
	/* ε */
	private Image loading_img;
	static final byte g_READY_GO = 6;
	
	public LoadingCanvas() {
		width = getWidth();
		height = getHeight();
		try {
			logo_img = Image.createImage("/images/title/logo.png");  // ΰ
			bg_img = Image.createImage("/images/title/bg_img.png");  // 
			title1 = Image.createImage("/images/title/title1.png");  // ﱹ
			title2 = Image.createImage("/images/title/title2.png");  // 
			title3 = Image.createImage("/images/title/title3.png");  // ÷
			menu_img1 = Image.createImage("/images/menu/00.png");    // ޴1
			menu_img2 = Image.createImage("/images/menu/01.png");    // ޴2
			cursor = Image.createImage("/images/menu/02.png");       // ޴ Ŀ
			loading_img = Image.createImage("/images/menu/loading.png");
		} catch (IOException e) { 
			System.out.println("̹    ϴ.");
		}
		largeFont = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_LARGE);
		italicFont = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_ITALIC | Font.STYLE_UNDERLINED, Font.SIZE_LARGE);
		gameState = g_LOGO;
		thread = new Thread(this);
		thread.start();     // run() ư
	}
	public void run() {
		while(true){
			try{thread.sleep(200);
			}catch(InterruptedException e){
				System.out.println(e);
			}
			repaint();      // paint() ȣ
		}
	}
	public void paint(Graphics g) {
		if(gameState == g_LOGO) {
			draw_logo(g);
		}else if (gameState == g_NOTICE){
			draw_notice(g);
		}else if (gameState == g_TITLE){
			if (!sound) soundPlay("title");
			draw_title(g);
		}else if (gameState == g_MENU){
			soundStop();
			draw_background_img(g);    // ȭ ʱȭ
			draw_menu(g);
		}else if (gameState == g_LOADING){
			draw_loading(g);
		}
	}
	public void draw_logo(Graphics g) {
		g.setColor(255,255,255);         // 
		g.fillRect(0, 0, getWidth(), getHeight());   // ü ȭ 
		g.drawImage(logo_img, getWidth()/2, getHeight()/2, Graphics.VCENTER | Graphics.HCENTER);		
		int x = getWidth()/2 - logo_img.getWidth()/2;
		int y = getHeight()/2 - logo_img.getHeight()/2;
		g.fillRect(x, y, logo_img.getWidth(), logo_img.getHeight()/2-logoCount);    
		g.fillRect(x, getHeight()/2+logoCount, logo_img.getWidth(), logo_img.getHeight()/2-logoCount); 
		if(logoCount < logo_img.getHeight()/2) logoCount+=1;
		else gameState = g_NOTICE;
	}
	public void draw_notice(Graphics g) {
		g.setColor(255,255,255);
		g.fillRect(0, 0, getWidth(), getHeight());		
		g.drawImage(bg_img, getWidth()/2, getHeight()/2, Graphics.VCENTER | Graphics.HCENTER);
		g.setColor(0,255,0);
		g.fillRect(25, 25, getWidth()-50, getHeight()-50);
		g.setColor(255,0,0);
		g.setFont(largeFont);
		g.drawString(explainText[0], getWidth()/2, 35, Graphics.TOP | Graphics.HCENTER);
		g.setColor(0,0,0);
		int y = 85;
		g.setFont(italicFont);
		for( byte i=1; i < explainText.length-1; i++){
			g.drawString(explainText[i], getWidth()/2, y, Graphics.TOP | Graphics.HCENTER);
			y+=20;
		}
		g.setColor(0,0,255);
		g.setFont(largeFont);
		g.drawString(explainText[6], getWidth()/2, y+50, Graphics.TOP | Graphics.HCENTER);
		if(isKeyPressed){
	    	switch(getGameAction(keyCode)) {			
	    		default:
	    			gameState = g_TITLE;
	    	}
	    }
		isKeyPressed = false;
	}
	public void draw_title(Graphics g) {
		g.drawImage(bg_img, 0, 0, Graphics.TOP | Graphics.LEFT);  // 
		g.drawImage(title1,0, 0, Graphics.TOP | Graphics.LEFT);
		g.drawImage(title2, getWidth()/2, title1.getHeight()+ 10, Graphics.TOP | Graphics.HCENTER);	
		g.drawImage(title3, getWidth()/2+50, title1.getHeight()+50, Graphics.TOP | Graphics.HCENTER);
		if(isKeyPressed){
	    	switch(getGameAction(keyCode)) {			
	    		default:
	    			gameState = g_MENU;
	    	}
	    }
		isKeyPressed = false;
	}
	public void draw_menu(Graphics g) {
		int tempY = height/2 -(menu_img2.getHeight()/2 );
		int tempH[] = {32, 30, 30, 32, 32, 34, 32};
		g.drawImage(menu_img1, width/2, height/2, Graphics.VCENTER | Graphics.HCENTER); 

		for( byte i=0; i < tempH.length; i++){
			if( menuSelect == i ){
				g.setClip(width/2-(menu_img2.getWidth() >> 1 ), tempY, menu_img2.getWidth(), tempH[i]);
				g.drawImage(menu_img2, width/2, height/2, Graphics.VCENTER|Graphics.HCENTER);
				g.setClip(0,0,width, height);
				g.drawImage(cursor, width/2-( menu_img2.getWidth() >> 1 ), tempY-3, Graphics.TOP|Graphics.RIGHT);
			}
			tempY += tempH[i];
		}
		if(isKeyPressed){
			switch(getGameAction(keyCode)) {	
	    		case UP:
	    			menuSelect--;
	    			if(menuSelect<0) menuSelect=6;
	    			soundPlay("menumov");
	    			break;
	    		case DOWN:
	    			menuSelect++;
	    			if(menuSelect>6) menuSelect=0;				
	    			soundPlay("menumov");
	    			break;
	    		case FIRE :
	    			if( menuSelect == 0 ){ //  
						gameState = g_LOADING;
						logoCount = 0;
	    			}
					break;
			}
		}
		isKeyPressed = false;
	}
	public void draw_loading(Graphics g){
		g.setColor(0,255,0);
		g.fillRect(0, 0, width, height);
		g.drawImage(loading_img, width/2, height/2, Graphics.VCENTER|Graphics.HCENTER);
		int x = width/2 - loading_img.getWidth()/2;
		int y = height/2 - loading_img.getHeight()/2;
		g.fillRect(x , y, loading_img.getWidth(), loading_img.getHeight()/2 -logoCount);    
		g.fillRect(x, height/2+logoCount, loading_img.getWidth(), loading_img.getHeight()/2-logoCount); 
		if( logoCount < 7 )		logoCount += 1;  
		else 	logoCount+=2;				
		if(logoCount >= 18  ){
			gameState = g_READY_GO;
			logoCount = 0;
		}
	}
	public void draw_background_img(Graphics g ){
		g.drawImage(bg_img, 0, 0, Graphics.TOP | Graphics.LEFT);
	}
	public void keyPressed(int keyCode) {
		isKeyPressed = true;
		this.keyCode = keyCode;
	}
	public void soundPlay(String name){
		soundStop();
		try	{
			InputStream in = getClass().getResourceAsStream("/"+name+".wav");
	  		mPlayer = Manager.createPlayer(in, "audio/x-wav");
	  		mPlayer.start();
		}catch(Exception e ){}
		sound = true;
	}
	final public void soundStop(){			
		if( mPlayer != null ) {
			try {
				mPlayer.stop();
				mPlayer = null;
				sound = false;
			}catch(Exception e) { }
		}
	}
}