import javax.microedition.lcdui.*;
import javax.microedition.media.*;
import java.io.*;

public class NoticeCanvas extends Canvas implements Runnable {
	private int logoCount;
	private byte gameState;
	private Thread thread;	
	private Image logo_img;
	private Image bg_img;
	static final byte g_LOGO = 1;
	static final byte g_NOTICE = 2;
	static final byte g_LOADING = 3;
	private Font largeFont;
	private Font italicFont;
	String explainText[] = {"< ̿ȳ  >", "  ̿ ", " ", "߻ ʴ ܵ", "Դϴ.", "Ƚϰ ̿ϼ.", "ƹ Ű ."};
	/* ̺Ʈ ó */
	private boolean isKeyPressed = false;
	private int keyCode;
	
	public NoticeCanvas() {
		try {
			logo_img = Image.createImage("/images/title/logo.png");  // ΰ
			bg_img = Image.createImage("/images/title/bg_img.png");  // 
		} catch(IOException e) { 
			System.out.println("̹    ϴ.");
		}
		largeFont = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_LARGE);
		italicFont = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_ITALIC | Font.STYLE_UNDERLINED, Font.SIZE_LARGE);
		gameState = g_LOGO;
		thread = new Thread(this);
		thread.start();     // run() ȣ
	}
	public void run() {
		while(true) {
			try {
				thread.sleep(200);
			} catch(InterruptedException e) {
				System.out.println(e);
			}
			repaint();      // paint() ȣ
		}
	}
	public void paint(Graphics g) {
		if(gameState == g_LOGO) {
			draw_logo(g);
		} else if(gameState == g_NOTICE) {
			draw_notice(g);
		}
	}
	public void draw_logo(Graphics g) {
		g.setColor(255, 255, 255);         // 
		g.fillRect(0, 0, getWidth(), getHeight());   // ü ȭ 
		g.drawImage(logo_img, getWidth()/2, getHeight()/2, Graphics.VCENTER | Graphics.HCENTER);		
		int x = getWidth()/2 - logo_img.getWidth()/2;
		int y = getHeight()/2 - logo_img.getHeight()/2;
		g.fillRect(x, y, logo_img.getWidth(), logo_img.getHeight()/2-logoCount);    
		g.fillRect(x, getHeight()/2+logoCount, logo_img.getWidth(), logo_img.getHeight()/2-logoCount); 
		if(logoCount < logo_img.getHeight()/2) logoCount+=1;
		else gameState = g_NOTICE;
	}
	public void draw_notice(Graphics g) {
		g.setColor(255, 255, 255);
		g.fillRect(0, 0, getWidth(), getHeight());		
		g.drawImage(bg_img, getWidth()/2, getHeight()/2, Graphics.VCENTER | Graphics.HCENTER);
		g.setColor(0, 255, 0);
		g.fillRect(25, 25, getWidth()-50, getHeight()-50);
		g.setColor(255, 0, 0);
		g.setFont(largeFont);
		g.drawString(explainText[0], getWidth()/2, 35, Graphics.TOP | Graphics.HCENTER);
		g.setColor(0, 0, 0);
		int y = 85;
		g.setFont(italicFont);
		for(byte i=1; i < explainText.length-1; i++) {
			g.drawString(explainText[i], getWidth()/2, y, Graphics.TOP | Graphics.HCENTER);
			y+=20;
		}
		g.setColor(0, 0, 255);
		g.setFont(largeFont);
		g.drawString(explainText[6], getWidth()/2, y+50, Graphics.TOP | Graphics.HCENTER);
		if(isKeyPressed) {
	    	switch(getGameAction(keyCode)) {			
	    		default:
	    			gameState = g_LOADING;
	    	}
	    }	
		isKeyPressed = false; 
	}	
	public void keyPressed(int keyCode) {
		isKeyPressed = true;
		this.keyCode = keyCode;
	}
}