import javax.microedition.lcdui.*;
import javax.microedition.media.*;

import java.io.*;

public class MenuCanvas extends Canvas implements Runnable {
	/* ΰ */
	private int logoCount;
	private byte gameState;
	private Thread thread;	
	private Image bg_img;
	private Image loading_img;
	/* ̺Ʈ ó */
	private boolean isKeyPressed = false;
	private int keyCode;
	/*  ó */
	private Player mPlayer;
	private boolean sound;
	/* ޴ ó */
	static final byte g_MENU = 4;
	static final byte g_LOADING = 5;
	private Image menu_img1, menu_img2, cursor;
	private byte menuSelect;
	private int width, height;
	
	public MenuCanvas() {
		width = getWidth();
		height = getHeight();
		try {
			bg_img = Image.createImage("/bg_img.png");       // 
			loading_img = Image.createImage("/loading.png"); // ε
			menu_img1 = Image.createImage("/00.png");        // ޴1
			menu_img2 = Image.createImage("/01.png");        // ޴2
			cursor = Image.createImage("/02.png");           // ޴ Ŀ
		} catch(IOException e) { 
			System.out.println("̹    ϴ.");
		}
		gameState = g_MENU;
		thread = new Thread(this);
		thread.start();     // run() ȣ
	}
	public void run() {
		while(true){
			try {
				Thread.sleep(200);
			} catch(InterruptedException e){
				System.out.println(e);
			}
			repaint();      // paint() ȣ
		}
	}
	public void paint(Graphics g) {
		if(gameState == g_MENU) {
			soundStop();
			draw_background_img(g);    //  ȭ ʱȭ
			draw_menu(g);
		}else if(gameState == g_LOADING) {
			draw_loading(g);
		}		
	}
	public void draw_menu(Graphics g) {
		int tempY = height/2 -(menu_img2.getHeight()/2 );
		int tempH[] = {32, 30, 30, 32, 32, 34, 32};
		g.drawImage(menu_img1, width/2, height/2, Graphics.VCENTER | Graphics.HCENTER); 

		for(byte i=0; i < tempH.length; i++) {
			if(menuSelect == i) {
				g.setClip(width/2-(menu_img2.getWidth() >> 1 ), tempY, menu_img2.getWidth(), tempH[i]);
				g.drawImage(menu_img2, width/2, height/2, Graphics.VCENTER|Graphics.HCENTER);
				g.setClip(0,0,width, height);
				g.drawImage(cursor, width/2-(menu_img2.getWidth() >> 1), tempY-3, Graphics.TOP|Graphics.RIGHT);
			}
			tempY += tempH[i];
		}
		if(isKeyPressed){
			switch(getGameAction(keyCode)) {	
	    		case UP:
	    			menuSelect--;
	    			if(menuSelect<0) menuSelect=6;
	    			soundPlay("menumov");
	    			break;
	    		case DOWN:
	    			menuSelect++;
	    			if(menuSelect>6) menuSelect=0;				
	    			soundPlay("menumov");
	    			break;
	    		case FIRE :
	    			if(menuSelect == 0 ) { //  
						gameState = g_LOADING;
						logoCount = 0;
	    			}
					break;
			}
		}
		isKeyPressed = false;
	}
	public void draw_loading(Graphics g) {
		g.setColor(0, 255, 0);
		g.fillRect(0, 0, width, height);
		g.drawImage(loading_img, width/2, height/2, Graphics.VCENTER|Graphics.HCENTER);
		int x = width/2 - loading_img.getWidth()/2;
		int y = height/2 - loading_img.getHeight()/2;
		g.fillRect(x , y, loading_img.getWidth(), loading_img.getHeight()/2 - logoCount);    
		g.fillRect(x, height/2 + logoCount, loading_img.getWidth(), loading_img.getHeight()/2 - logoCount); 
		if(logoCount < 7)	logoCount += 1;  
		else logoCount+=2;				
		if(logoCount >= 18) {
			gameState = g_MENU;
			logoCount = 0;
		}
	}
	public void draw_background_img(Graphics g) {
		g.drawImage(bg_img, 0, 0, Graphics.TOP | Graphics.LEFT);
	}
	public void keyPressed(int keyCode) {
		isKeyPressed = true;
		this.keyCode = keyCode;
	}
	public void soundPlay(String name) {
		soundStop();
		try	{
			InputStream in = getClass().getResourceAsStream("/"+name+".wav");
	  		mPlayer = Manager.createPlayer(in, "audio/x-wav");
	  		mPlayer.start();
		}catch (Exception e) {  }
		sound = true;
	}
	final public void soundStop() {			
		if(mPlayer != null) {
			try {
				mPlayer.stop();
				mPlayer = null;
				sound = false;
			}catch(Exception e) { }
		}
	}
}